
#   nedit.tcl      NetVar editor

set frame NEDIT
set title "NetVar Editor"
set icontitle NEdit

set Option ""
set value ""

set RegisterServer NetVar
set Info {}

proc Get_NetVars {} {
   global Info
    
   set Info [first [read-registers NetVar*]]
}

proc click_value {v} {
    global Option value
    
    set value $v

    write-register $Option $value
}

proc click_list {v} {
    global Option value
    
    set Option [first $v]
    set value [lreplace $v 0 0]
    
    :modify OPTION :value $Option
    :modify VALUE :value $value
}

proc display_NetVars {} {
   global Info

    set l {}
    foreach item $Info {
        set Option [first $item]
        set value [first [split [second $item]]]
        lappend l "[format "%40s%40s" $Option $value]"
    }
    :modify LIST :append F :strings [lsort -dictionary -index 0 $l] :see 0
}

proc Update {} {Get_NetVars; display_NetVars}

proc click arg {
   global debug Option
   if {$debug} then {insert-debug "click with argument \{$arg\}"}

   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   set i [lindex $arg 4]
   if {$c==":quit"} then {return [click-quit $f]}
   switch -glob $w {

      OPTION      {set Option $v}
      VALUE       {click_value $v}
      
      LIST        {click_list $v}

      default {
         set p "click-[lowercase $w]"
         if {[info procs $p] == "$p"} then {$p $v} else {set-footer "no handler for widget $w"}
      }
   }
}

proc make-frame {} {
   global keys

  :frame [self frame-name] :label "[self frame-title]" :show-footer T :resize F \
      :icon-name "[self icon-title]"
      
     :panel P1 :layout T
       :list LIST :rows 20  :cols 80 :exclusive T :scroll B
       
     :panel P2 :layout B :padx 10 :pady 10
      :layout H; :col-gap 20; :row-gap 5
         :text OPTION  :label "Option" :w 35 :shifters T
         :text VALUE   :label "Value"  :w 35 :shifters T
        :next-row T
         :button UPDATE :command Update

   :show T
}

proc start args {
   global started
   
   make-frame
   set started 1

   Update

}


