
lappend registerlist [list NetVar.V1724_NumSamples     generic  "-n V1724_NumSamples -t int"]
lappend registerlist [list NetVar.V1724_VMERetries     generic  "-n V1724_VMERetries -t int"]
lappend registerlist [list NetVar.V1724_BERREnable     generic  "-n V1724_BERREnable -t int"]
lappend registerlist [list NetVar.V1724_VMEBufSize     generic  "-n V1724_VMEBufSize -t int"]

lappend registerlist [list NetVar.V1724_TraceOpt generic  "-n V1724_TraceOpt -t int"]
lappend registerlist [list NetVar.V1724_Trig generic  "-n V1724_Trig -t int"]
lappend registerlist [list NetVar.V1724_DVP  generic  "-n V1724_DVP -t int"]
lappend registerlist [list NetVar.V1724_Diag  generic  "-n V1724_Diag -t int"]

lappend registerlist [list NetVar.V1495_UseCtrl        generic   "-n V1495_UseCtrl -t int"]

set V1724_Base 64

proc Set_V1724_Options {} {
    global Options V1724_Base

    load_Options

   if {![info exists Options(Use1495)]}                     {set Options(Use1495) 1}
   if {![info exists Options(Usepatterngen)]}               {set Options(Usepatterngen) 0}

   if {![info exists Options(V1724_DPP)]}                   {set Options(V1724_DPP) 1}
   if {![info exists Options(V1724_TraceOpt)]}              {set Options(V1724_TraceOpt) 0}
   if {![info exists Options(V1724_Trig)]}                  {set Options(V1724_Trig) 0}
   if {![info exists Options(V1724_DVP)]}                   {set Options(V1724_DVP) 0}
   if {![info exists Options(V1724_Diag)]}                  {set Options(V1724_Diag) 0}
   if {![info exists Options(V1724_MaxEvtsPerBuf)]}         {set Options(V1724_MaxEvtsPerBuf) 1}
   if {![info exists Options(V1724_MaxBLT)]}                {set Options(V1724_MaxBLT) 1}
   if {![info exists Options(V1724_MemBufSize)]}            {set Options(V1724_MemBufSize) 1024}
   if {![info exists Options(V1724_VMEBufSize)]}            {set Options(V1724_VMEBufSize) 16384}

   if {![info exists Options(V1724_Hist_Diag.Enable)]}      {set Options(V1724_Hist_Diag.Enable) 0}
   if {![info exists Options(V1724_Hist_Diag.channels)]}    {set Options(V1724_Hist_Diag.channels) 16384}

   if {![info exists Options(V1724_Hist_TraceA.Enable)]}    {set Options(V1724_Hist_TraceA.Enable) 1}
#   if {![info exists Options(V1724_Hist_TraceB.Enable)]}    {set Options(V1724_Hist_TraceB.Enable) 0}
set Options(V1724_Hist_TraceB.Enable) 0
   if {![info exists Options(V1724_Hist_Energy.Enable)]}    {set Options(V1724_Hist_Energy.Enable) 1}
   if {![info exists Options(V1724_Hist_BaseLine.Enable)]}    {set Options(V1724_Hist_BaseLine.Enable) 1}
   if {![info exists Options(V1724_Hist_TimeH.Enable)]}     {set Options(V1724_Hist_TimeH.Enable) 0}
   if {![info exists Options(V1724_Hist_TimeL.Enable)]}     {set Options(V1724_Hist_TimeL.Enable) 0}
   if {![info exists Options(V1724_Hist_TraceA.channels)]}  {set Options(V1724_Hist_TraceA.channels) 512}
   if {![info exists Options(V1724_Hist_TraceA.offset)]}    {set Options(V1724_Hist_TraceA.offset) 0}
   if {![info exists Options(V1724_Hist_TraceA.shift)]}     {set Options(V1724_Hist_TraceA.shift) 0}
#   if {![info exists Options(V1724_Hist_TraceB.channels)]}  {set Options(V1724_Hist_TraceB.channels) 512}
#   if {![info exists Options(V1724_Hist_TraceB.offset)]}    {set Options(V1724_Hist_TraceB.offset) 0}
#   if {![info exists Options(V1724_Hist_TraceB.shift)]}     {set Options(V1724_Hist_TraceB.shift) 0}
   if {![info exists Options(V1724_Hist_Energy.channels)]}  {set Options(V1724_Hist_Energy.channels) 32768}
   if {![info exists Options(V1724_Hist_Energy.offset)]}    {set Options(V1724_Hist_Energy.offset) 0}
   if {![info exists Options(V1724_Hist_Energy.shift)]}     {set Options(V1724_Hist_Energy.shift) 0}
   if {![info exists Options(V1724_Hist_BaseLine.channels)]}  {set Options(V1724_Hist_BaseLine.channels) 65536}
   if {![info exists Options(V1724_Hist_BaseLine.offset)]}    {set Options(V1724_Hist_BaseLine.offset) 0}
   if {![info exists Options(V1724_Hist_BaseLine.shift)]}     {set Options(V1724_Hist_BaseLine.shift) 0}
   if {![info exists Options(V1724_Hist_TimeH.channels)]}   {set Options(V1724_Hist_TimeH.channels) 65536}
   if {![info exists Options(V1724_Hist_TimeH.offset)]}     {set Options(V1724_Hist_TimeH.offset) 0}
   if {![info exists Options(V1724_Hist_TimeH.shift)]}      {set Options(V1724_Hist_TimeH.shift) 0}
   if {![info exists Options(V1724_Hist_TimeL.channels)]}   {set Options(V1724_Hist_TimeL.channels) 65536}
   if {![info exists Options(V1724_Hist_TimeL.offset)]}     {set Options(V1724_Hist_TimeL.offset) 0}
   if {![info exists Options(V1724_Hist_TimeL.shift)]}      {set Options(V1724_Hist_TimeL.shift) 0}
   if {![info exists Options(V1724_GroupBase)]}             {set Options(V1724_GroupBase) $V1724_Base}
   set V1724_Base  $Options(V1724_GroupBase)

    update_Options
}

proc V1724_Configure {} {
    global VMEserver Options

    set VME_BUFFER_SIZE [read-register NetVar.V1724_VMEBufSize]
    set Options(V1724_VMEBufSize) $VME_BUFFER_SIZE

      update_Options

    write-register NetVar.V1724_Trig $Options(V1724_Trig)
    write-register NetVar.V1724_DVP  $Options(V1724_DVP)
    write-register NetVar.V1724_Diag  $Options(V1724_Diag)

           switch $Options(V1724_MemBufSize) {
              65536 {set BUFF_ORG 2; set BUFF_NUM 4}
              32768 {set BUFF_ORG 3; set BUFF_NUM 8}
              16384 {set BUFF_ORG 4; set BUFF_NUM 16}
              8192  {set BUFF_ORG 5; set BUFF_NUM 32}
              4096  {set BUFF_ORG 6; set BUFF_NUM 64}
              2048  {set BUFF_ORG 7; set BUFF_NUM 128}
              1024  {set BUFF_ORG 8; set BUFF_NUM 256}
              512   {set BUFF_ORG 9; set BUFF_NUM 512}
              256   {set BUFF_ORG 10; set BUFF_NUM 1024}
              default {set BUFF_ORG 10; set BUFF_NUM 1024}
           }

      set z [catch {eg "(register :name '/$VMEserver/v1724#1.VMEStatus'  ?object)" } m]
      if {$z==0} then {

        write-registers v1724#1.VMEControl 16   ;# force BERR option

           set SIZE [read-register v1724#1.CustomSize]
           if {$SIZE == 0} {set SIZE 32}
           write-register NetVar.V1724_NumSamples $SIZE

           set NUM [expr (($Options(V1724_MemBufSize) - 2) * 2) / $SIZE]
           if {$NUM > $Options(V1724_MaxEvtsPerBuf)} {set NUM $Options(V1724_MaxEvtsPerBuf)}

           set BERR [read-register v1724#1.VMEControl]  ;#  enable BERR to finish a VME block transfer
           write-register NetVar.V1724_BERREnable [expr ($BERR >> 4) & 1]

puts "V1724 Output buffers $BUFF_NUM  @ $Options(V1724_MemBufSize) 32 bit words"
puts "Waveform [expr $SIZE * 2] samples"
puts "8 channels; $NUM events/buffer"

         set osize [expr (($SIZE + 2) * $NUM) + 2]
puts "V1724 buffer size used $osize words out of max $Options(V1724_MemBufSize)"

        if {$osize > $Options(V1724_MemBufSize)} {
           midas-warning "Number of samples or Events per buffer is too big\n\
                 $osize > $Options(V1724_MemBufSize) - this is not permitted\n\
                 correct options and try again"
           return
        }

         set BLT [expr $VME_BUFFER_SIZE / (($osize * 8) + 4)]
         if {$BLT > $Options(V1724_MaxBLT)} {set BLT $Options(V1724_MaxBLT)}

puts "BLT Event Number = $BLT"
         set isize [expr (($osize * 8) + 4) * $BLT]
puts "Data Acq Input buffer size used $isize words out of max $VME_BUFFER_SIZE"
      }

       write-registers v1724#*.VMEControl $BERR     ;# set all modules to same setting
       write-registers v1724#*.CustomSize $SIZE     ;# set all modules to same setting

       write-registers v1724#*.BufferOrg $BUFF_ORG
       write-registers v1724#\[?,??\].EvtsPerBuf $NUM

       write-registers v1724#*.BLTEventNum $BLT     ;# set all modules to same setting

    if {$Options(Use1495) == 1} {write-registers v1495#1.ArmLimit $BLT}
    write-register NetVar.V1495_UseCtrl  $Options(Use1495)

}

proc V1724_DAQ-go {} {
    global Options

    if {$Options(V1724_DPP) == 0} {return}    ;# not DPP - handled by V17XX_DAQ-go

#       write-registers v1724#*.Clear 0
    write-registers v1724#*.AcqControl 4
}

proc V1724_DAQ-halt {} {
    global Options

    if {$Options(V1724_DPP) == 0} {return}    ;# not DPP - handled by V17XX_DAQ-halt

    write-registers v1724#*.AcqControl 0
}

proc V1724_DAQ-setup {} {
    global Options

    if {$Options(V1724_DPP) == 0} {return}    ;# not DPP - handled by V17XX_DAQ-setup

     V1724_Configure
}

proc V1724_DAQ-flush {} {}

proc V1724_DAQ-reset {} {}

proc Dump_Raw_VME_Data_V1724 {data} {

   set info ""

    foreach word $data {
         if {[string range $word 0 1] != "0x"} then {set word 0x$word}
         if {$word == 0xaa5555aa} then {
             append info "$word - end of dump\n"
             break
         }
         if {$word == 0x55aaaa55} then {
             append info "$word - end of event\n"
             continue
         }
         append info "$word "
    }

   append info "\n"

   return $info
}


proc define_V1724_config {} {
    global VMEserver Options
    global V1724_Base

#   set maxmodule [inform vmecontrol inquire v1724count]
#   if {[string length $maxmodule] > 2} {set maxmodule 0}

    if {$Options(V1724_DPP) == 0} {return}    ;# not DPP 

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {eg "(register :name '/$VMEserver/v1724#$i.VMEStatus'  ?object)" } m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   if {$maxmodule > 0} then {DefineConfig "1724 0 [format "0x%x" $V1724_Base]"}

   for {set i 1} {$i <= $maxmodule} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v1724#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v1724#$i.Output_Buffer"
          clear-footer
          error $m
      }
      DefineConfig "1724 $i [string range [first $m] 2 end]"
   }
}

proc create_V1724_spectra {} {
    global SpectrumServer VMEserver
    global V1724_Base
    global Options 

#   set maxmodule [inform vmecontrol inquire v1724count]
#   if {[string length $maxmodule] > 2} {set maxmodule 0}

    if {$Options(V1724_DPP) == 0} {return}    ;# not DPP 

   set maxmodule 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {eg "(register :name '/$VMEserver/v1724#$i.VMEStatus'  ?object)" } m]
      if {$z!=0} then {break}
      incr maxmodule
   }

   set UseGroup [read-register NetVar.UseGroup]

   for {set i 1} {$i <= $maxmodule} {incr i} {

     if {$Options(V1724_Hist_Diag.Enable) == 1} {

#    histograms for diagnostics output

           set spectrumname [SpectrumName v1724#$i.Diag]
           set-footer "Creating $spectrumname"
           set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(V1724_Hist_Diag.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              display-eg-error-report self $m "Attempting to create spectrum $spectrumname"
              clear-footer
              error $m
           } else {
               map_spectrum  "$spectrumname 0 $i 0 0"
           }
     }

     if {$Options(V1724_Hist_Energy.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the computed energy

           set spectrumname [SpectrumName v1724#$i.E[set j]]
           set-footer "Creating $spectrumname"
           set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(V1724_Hist_Energy.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              display-eg-error-report self $m "Attempting to create spectrum $spectrumname"
              clear-footer
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1724_Base]
                   set item [expr $j + (0 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1724_Base]
                   set item 0
               }
               map_spectrum  "$spectrumname $group $item $Options(V1724_Hist_Energy.offset) $Options(V1724_Hist_Energy.shift)"

           }
        }
     }

     if {$Options(V1724_Hist_BaseLine.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the base line

           set spectrumname [SpectrumName v1724#$i.B[set j]]
           set-footer "Creating $spectrumname"
           set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(V1724_Hist_BaseLine.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              display-eg-error-report self $m "Attempting to create spectrum $spectrumname"
              clear-footer
              error $m
           } else {

               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1724_Base]
                   set item [expr $j + (1 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1724_Base]
                   set item 1
               }
               map_spectrum  "$spectrumname $group $item $Options(V1724_Hist_BaseLine.offset) $Options(V1724_Hist_BaseLine.shift)"

           }
        }
     }


     if {$Options(V1724_Hist_TimeH.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the time (MSW)

           set spectrumname [SpectrumName v1724#$i.TH[set j]]
           set-footer "Creating $spectrumname"
           set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(V1724_Hist_TimeH.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              display-eg-error-report self $m "Attempting to create spectrum $spectrumname"
              clear-footer
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1724_Base]
                   set item [expr $j + (2 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1724_Base]
                   set item 2
               }
              map_spectrum  "$spectrumname $group $item $Options(V1724_Hist_TimeH.offset) $Options(V1724_Hist_TimeH.shift)"
           }
        }
     }

    if {$Options(V1724_Hist_TimeL.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the time (LSW)

           set spectrumname [SpectrumName v1724#$i.TL[set j]]
           set-footer "Creating $spectrumname"
           set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(V1724_Hist_TimeL.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              display-eg-error-report self $m "Attempting to create spectrum $spectrumname"
              clear-footer
              error $m
           } else {
               if {$UseGroup == 0} {
                   set group [expr ($i - 1) + $V1724_Base]
                   set item [expr $j + (3 << 3)]
               } else {
                   set group [expr (($i - 1) * 8) + $j + $V1724_Base]
                   set item 3
               }
              map_spectrum  "$spectrumname $group $item $Options(V1724_Hist_TimeL.offset) $Options(V1724_Hist_TimeL.shift)"
           }
        }
     }

     if {$Options(V1724_Hist_TraceA.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the data trace A

           set spectrumname [SpectrumName v1724#$i.ChA[set j]]
           set-footer "Creating $spectrumname"
           set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(V1724_Hist_TraceA.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              display-eg-error-report self $m "Attempting to create spectrum $spectrumname"
              clear-footer
              error $m
           } else {
              set group  [expr (($i-1) * 8) + $j + 256  + $V1724_Base] 
              map_spectrum  "$spectrumname $group 0 $Options(V1724_Hist_TraceA.offset) $Options(V1724_Hist_TraceA.shift)"
           }
        }
     }

     if {$Options(V1724_Hist_TraceB.Enable) == 1} {

        for {set j 0} {$j < 8} {incr j} {   

#    histograms for the data trace B

           set spectrumname [SpectrumName v1724#$i.ChB[set j]]
           set-footer "Creating $spectrumname"
           set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(V1724_Hist_TraceB.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              display-eg-error-report self $m "Attempting to create spectrum $spectrumname"
              clear-footer
              error $m
           } else {
              set group  [expr (($i-1) * 8) + $j + 384  + $V1724_Base] 
              map_spectrum  "$spectrumname $group 0 $Options(V1724_Hist_TraceB.offset) $Options(V1724_Hist_TraceB.shift)"
           }
        }
     }
   }
}

