
lappend registerlist [list NetVar.V17XX_NumSamples     generic  "-n V17XX_NumSamples -t int"]
lappend registerlist [list NetVar.V17XX_VMERetries     generic  "-n V17XX_VMERetries -t int"]
lappend registerlist [list NetVar.V17XX_BERREnable     generic  "-n V17XX_BERREnable -t int"]
lappend registerlist [list NetVar.V17XX_VMEBufSize     generic  "-n V17XX_VMEBufSize -t int"]

lappend registerlist [list NetVar.V17XX_TraceOpt generic  "-n V17XX_TraceOpt -t int"]
lappend registerlist [list NetVar.V17XX_Diag  generic  "-n V17XX_Diag -t int"]

set V17XX_Base 128
set V17XX_Modules [list v1720 v1724 v1740 v1742]

proc Set_V17XX_Options {} {
    global Options V17XX_Base

    load_Options

   if {![info exists Options(V17XX_TraceOpt)]}              {set Options(V17XX_TraceOpt) 0}
   if {![info exists Options(V17XX_Diag)]}                  {set Options(V17XX_Diag) 0}
   if {![info exists Options(V17XX_MaxBLT)]}                {set Options(V17XX_MaxBLT) 1}
   if {![info exists Options(V17XX_MemBufSize)]}            {set Options(V17XX_MemBufSize) 1024}
   if {![info exists Options(V17XX_VMEBufSize)]}            {set Options(V17XX_VMEBufSize) 16384}

   if {![info exists Options(V17XX_Hist_Diag.Enable)]}      {set Options(V17XX_Hist_Diag.Enable) 0}
   if {![info exists Options(V17XX_Hist_Diag.channels)]}    {set Options(V17XX_Hist_Diag.channels) 65536}

   if {![info exists Options(V17XX_Hist_TraceA.Enable)]}    {set Options(V17XX_Hist_TraceA.Enable) 0}
   if {![info exists Options(V17XX_Hist_TraceA.channels)]}  {set Options(V17XX_Hist_TraceA.channels) 65536}
   if {![info exists Options(V17XX_Hist_TraceA.offset)]}    {set Options(V17XX_Hist_TraceA.offset) 0}
   if {![info exists Options(V17XX_Hist_TraceA.shift)]}     {set Options(V17XX_Hist_TraceA.shift) 0}

   if {![info exists Options(V17XX_GroupBase)]}             {set Options(V17XX_GroupBase) $V17XX_Base}
   set V17XX_Base  $Options(V17XX_GroupBase)

    update_Options
}


proc V17XX_DAQ-go {} {
    global VMEserver Options
    global V17XX_Modules

#    set VME_BUFFER_SIZE [read-register NetVar.V17XX_VMEBufSize]
#    set Options(V17XX_VMEBufSize) $VME_BUFFER_SIZE

      update_Options

#    write-register NetVar.V17XX_Diag  $Options(V17XX_Diag)

  foreach type $V17XX_Modules {

    for {set i 1} {$i <= 16} {incr i} {
      set z [catch {eg "(register :name '/$VMEserver/[set type]#$i.VMEStatus'  ?object)" } m]
      if {$z!=0} then {break}

      if {$i == 1} {

        write-registers [set type]#1.VMEControl 16   ;# force BERR option

           set BERR [read-register [set type]#1.VMEControl]  ;#  enable BERR to finish a VME block transfer
           write-register NetVar.V17XX_BERREnable [expr ($BERR >> 4) & 1]

         set BLT 1
         if {$BLT > $Options(V17XX_MaxBLT)} {set BLT $Options(V17XX_MaxBLT)}

      }

       write-registers [set type]#$i.VMEControl $BERR     ;# set all modules to same setting

       write-registers [set type]#$i.Clear 0
       write-registers [set type]#$i.BLTEventNum $BLT     ;# set all modules to same setting

       write-registers [set type]#$i.AcqControl 4
    }
  }
}


proc V17XX_DAQ-halt {} {
    global VMEserver
    global V17XX_Modules

  foreach type $V17XX_Modules {

    for {set i 1} {$i <= 16} {incr i} {
       set z [catch {eg "(register :name '/$VMEserver/[set type]#$i.VMEStatus'  ?object)" } m]
       if {$z!=0} then {break}

       write-registers [set type]#$i.AcqControl 0
    }

  }
}


proc V17XX_Disable {} {
    global VMEserver
    global V17XX_Modules

  foreach type $V17XX_Modules {

    for {set i 1} {$i <= 16} {incr i} {
       set z [catch {eg "(register :name '/$VMEserver/[set type]#$i.VMEStatus'  ?object)" } m]
       if {$z!=0} then {break}

       write-registers [set type]#$i.Enable 0
    }
  }

}

proc V17XX_DAQ-setup {} {}

proc V17XX_DAQ-flush {} {}

proc V17XX_DAQ-reset {} {}

proc Dump_Raw_VME_Data_V17XX {data} {

   set info ""

    foreach word $data {
         if {[string range $word 0 1] != "0x"} then {set word 0x$word}
         if {$word == 0xaa5555aa} then {
             append info "$word - end of dump\n"
             break
         }
         if {$word == 0x55aaaa55} then {
             append info "$word - end of event\n"
             continue
         }
         append info "$word "
    }

   append info "\n"

   return $info
}

set Num17XX 0
set Num1720 0
set Num1724 0
set Num1740 0
set Num1742 0

proc define_V17XX_config {} {
    global VMEserver Options
    global V17XX_Base
    global Num17XX
    global Num1720
    global Num1724
    global Num1740
    global Num1742

#   set maxmodule [inform vmecontrol inquire v17XXcount]
#   if {[string length $maxmodule] > 2} {set maxmodule 0}

   set Num1720 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {eg "(register :name '/$VMEserver/v1720#$i.VMEStatus'  ?object)" } m]
      if {$z!=0} then {break}
      incr Num1720
   }

   set Num1724 0
   for {set i 1} {$i <= 16} {incr i} {
      if {$Options(V1724_DPP) != 0} {break}
      set z [catch {eg "(register :name '/$VMEserver/v1724#$i.VMEStatus'  ?object)" } m]
      if {$z!=0} then {break}
      incr Num1724
   }

   set Num1740 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {eg "(register :name '/$VMEserver/v1740#$i.VMEStatus'  ?object)" } m]
      if {$z!=0} then {break}
      incr Num1740
   }

   set Num1742 0
   for {set i 1} {$i <= 16} {incr i} {
      set z [catch {eg "(register :name '/$VMEserver/v1742#$i.VMEStatus'  ?object)" } m]
      if {$z!=0} then {break}
      incr Num1742
   }

   set Num17XX [expr $Num1720 + $Num1724 + $Num1740 + $Num1742]

   if {$Num17XX == 0} then {return}

   DefineConfig "1700 0 [format "0x%x" $V17XX_Base]"

   set Num17XX 0

   for {set i 1} {$i <= $Num1720} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v1720#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v1720#$i.Output_Buffer"
          clear-footer
          error $m
      }
      incr Num17XX
      DefineConfig "1700 $Num17XX [string range [first $m] 2 end]"
   }

   for {set i 1} {$i <= $Num1724} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v1724#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v1724#$i.Output_Buffer"
          clear-footer
          error $m
      }

      incr Num17XX
      DefineConfig "1700 $Num17XX [string range [first $m] 2 end]"
   }

   for {set i 1} {$i <= $Num1740} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v1740#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v1740#$i.Output_Buffer"
          clear-footer
          error $m
      }
      incr Num17XX
      DefineConfig "1700 $Num17XX [string range [first $m] 2 end]"
   }

   for {set i 1} {$i <= $Num1742} {incr i} {

      set z [catch {eg "(register :name '/$VMEserver/v1742#$i.Output_Buffer'  ?object)" } m]
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to locate register v1742#$i.Output_Buffer"
          clear-footer
          error $m
      }
      incr Num17XX
      DefineConfig "1700 $Num17XX [string range [first $m] 2 end]"
   }
}

proc create_V17XX_spectra {} {
    global SpectrumServer VMEserver
    global V17XX_Base
    global Num17XX
    global Options 

#   set maxmodule [inform vmecontrol inquire v17XXcount]
#   if {[string length $maxmodule] > 2} {set maxmodule 0}

   set UseGroup [read-register NetVar.UseGroup]

   for {set i 1} {$i <= $Num17XX} {incr i} {

     if {$Options(V17XX_Hist_Diag.Enable) == 1} {

#    histograms for diagnostics output

           set spectrumname [SpectrumName v17XX#$i.Diag]
           set-footer "Creating $spectrumname"
           set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(V17XX_Hist_Diag.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              display-eg-error-report self $m "Attempting to create spectrum $spectrumname"
              clear-footer
              error $m
           } else {
               map_spectrum  "$spectrumname 0 $i 0 0"
           }
     }

     if {$Options(V17XX_Hist_TraceA.Enable) == 1} {

#    histograms for the data buffer

           set spectrumname [SpectrumName v17XX#$i.Data]
           set-footer "Creating $spectrumname"
           set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $Options(V17XX_Hist_TraceA.channels) :name '$spectrumname' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
           if {$z!=0 && $m==0x30004} then {set z 0}
           if {$z!=0} then {
              display-eg-error-report self $m "Attempting to create spectrum $spectrumname"
              clear-footer
              error $m
           } else {
              set group  [expr ($i-1) + 256 + $V17XX_Base] 
              map_spectrum  "$spectrumname $group 0 $Options(V17XX_Hist_TraceA.offset) $Options(V17XX_Hist_TraceA.shift)"
           }
     }

   }
}

